
import VueControleur.VueControleurPacMan;
import modele.Jeu;
import modele.Menu;
import modele.Pacman;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author freder
 */
public class Main {
    public static void main(String[] args) throws InterruptedException {
        
        Jeu jeu = new Jeu();
        Menu menu = new Menu();
        
        VueControleurPacMan vc = new VueControleurPacMan(Jeu.SIZE_X, Jeu.SIZE_Y);
     	
    	jeu.addObserver(vc);
    	menu.addObserver(vc);   

        vc.setAffichage(menu);
        vc.setVisible(true);
        
        while(vc.quit == false)
        {      
        	menu.reInitMenu();
        	while(!vc.quit && !menu.game)
        	{
        		menu.run();
        	}
        	if(vc.quit)
        		break;
        	
        	
	        vc.setAffichage(jeu);
	        jeu.start();
	        
	        while(!jeu.getEnding())
				try {
					Thread.sleep(10);
				} catch (InterruptedException e) {
					vc.quit = true;
				}
	        
	        vc.setAffichage(menu);	        
        }
		vc.dispose();
    }
}
