/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package modele;
import java.awt.Point;
import java.util.ArrayList;
import java.util.Random;
/**
 *
 * @author freder
 */

public abstract class Fantome extends Entite {

    private modeFantome mode;
    protected int tempsAvantChangeMode;

    protected Random r = new Random();

    public Fantome(Jeu _jeu, Point pt) {
        super(_jeu, pt);
        mode = modeFantome.explore;
        d = Direction.haut;
    }

    
    @Override
    public void choixDirection() {
    	gestionMode();
    	if(mode == modeFantome.explore)
    	{
    		ArrayList<Direction> lstdir = jeu.getGestEnt().dirDispo(this);
    		if(lstdir.size() == 1)
    			d = lstdir.get(0);
    		else
    		{
    			lstdir.remove(d);
    			lstdir.remove(jeu.getGestEnt().dirOppose(d));
        		if(lstdir.size() > 0)
        		{
        			int i = r.nextInt(lstdir.size());
        			d = lstdir.get(i);
        		}
    		}
    	}
    	else
    		d = choixDirectionChasse();
    }
    
    public void gestionMode()
    {
    	tempsAvantChangeMode-=1;
    	if(tempsAvantChangeMode == 0)
    	{
    		if(mode == modeFantome.chasse)
    		{
    			mode = modeFantome.explore;
    			tempsAvantChangeMode = 14;
    		}
    		else
    		{
    			mode = modeFantome.chasse;
    			tempsAvantChangeMode = 20;
    		}
    	}
    }
    
    protected abstract Direction choixDirectionChasse();
    
}
